import 'dart:async';
import 'dart:ui';

class Cancelable<O> {
  final Completer<O> _completer;
  final VoidCallback onCancel;

  Cancelable(this._completer, this.onCancel);

  Future<O> get result => _completer.future;

  void cancel() {
    onCancel();
    _completer.completeError(CanceledError());
  }
}

class CanceledError implements Exception {}
